////////////////////////////////////////////////////////////////
// 目覚し時計ガジェット
//   Copyright (C) 2008 - 2012 AAOh inc.
////////////////////////////////////////////////////////////////

/**
 * @fileOverview 目覚し時計ガジェット
 * @author       $Author: fujishiro $
 */

(function () {
/**
 * Option。
 *
 * @constructor
 */
aclock.Option = aaoh.kaze.Gadget.extend(
	aaoh.sora.OptionEx, function() {
	this.filter      = null;
	this.filterName1 = null;
	this.filterExt1  = null;
	this.filterName2 = null;
	this.filterExt2  = null;
});
	/**
	 * アラートの設定。
	 */
	aclock.Option.prototype.
	setAlert = function() {
		var cbxAlert    = aaoh.kaze.Gadget.$('cbxAlert');
		var cbxAlertDef = aaoh.kaze.Gadget.$('cbxAlertDef');
		var lblAlertDef = aaoh.kaze.Gadget.$('lblAlertDef');
		var txtAlert    = aaoh.kaze.Gadget.$('txtAlert');

		var isAlert  = aaoh.kaze.Element.isChecked(cbxAlert);
		if (isAlert) {
			aaoh.kaze.Element.setEnabled(cbxAlertDef, true);
			aaoh.kaze.Element.setEnabled(lblAlertDef, true);
			this.setAlertMsg();

		} else {
			aaoh.kaze.Element.setEnabled(cbxAlertDef, false);
			aaoh.kaze.Element.setEnabled(lblAlertDef, false);
			aaoh.kaze.Element.setEnabled(txtAlert,    false);
		}
	}

	/**
	 * アラートの設定。
	 */
	aclock.Option.prototype.
	setAlertMsg = function() {
		var cbxAlertDef = aaoh.kaze.Gadget.$('cbxAlertDef');
		var txtAlert    = aaoh.kaze.Gadget.$('txtAlert');

		var isAlertDef = aaoh.kaze.Element.isChecked(cbxAlertDef);
		if (isAlertDef) {
			aaoh.kaze.Element.setEnabled(txtAlert, false);
			aaoh.kaze.Element.setValue(
				txtAlert, aaoh.sora.App.control.DEFAULT_ALERT_MSG
			);

		} else {
			aaoh.kaze.Element.setEnabled(txtAlert, true);
		}
	}

	/**
	 * 音の設定。
	 */
	aclock.Option.prototype.
	setSound = function() {
		var cbxSound      = aaoh.kaze.Gadget.$('cbxSound');
		var cbxSoundDef   = aaoh.kaze.Gadget.$('cbxSoundDef');
		var lblSoundDef   = aaoh.kaze.Gadget.$('lblSoundDef');
		var txtSound      = aaoh.kaze.Gadget.$('txtSound');
		var btnSound      = aaoh.kaze.Gadget.$('btnSound');
		var selSoundVol   = aaoh.kaze.Gadget.$('selSoundVol');
		var btnSoundStart = aaoh.kaze.Gadget.$('btnSoundStart');
		var btnSoundStop  = aaoh.kaze.Gadget.$('btnSoundStop');

		var isSound  = aaoh.kaze.Element.isChecked(cbxSound);
		if (isSound) {
			aaoh.kaze.Element.setEnabled(cbxSoundDef,   true);
			aaoh.kaze.Element.setEnabled(lblSoundDef,   true);
			this.setSoundFile();
			aaoh.kaze.Element.setEnabled(selSoundVol,   true);
			aaoh.kaze.Element.setEnabled(btnSoundStart, true);
			aaoh.kaze.Element.setEnabled(btnSoundStop,  true);

		} else {
			aaoh.kaze.Element.setEnabled(cbxSoundDef,   false);
			aaoh.kaze.Element.setEnabled(lblSoundDef,   false);
			aaoh.kaze.Element.setEnabled(txtSound,      false);
			aaoh.kaze.Element.setEnabled(btnSound,      false);
			aaoh.kaze.Element.setEnabled(selSoundVol,   false);
			aaoh.kaze.Element.setEnabled(btnSoundStart, false);
			aaoh.kaze.Element.setEnabled(btnSoundStop,  false);
		}
	}

	/**
	 * 音の設定。
	 */
	aclock.Option.prototype.
	setSoundFile = function() {
		var cbxSoundDef = aaoh.kaze.Gadget.$('cbxSoundDef');
		var txtSound    = aaoh.kaze.Gadget.$('txtSound');
		var btnSound    = aaoh.kaze.Gadget.$('btnSound');

		var isSoundDef = aaoh.kaze.Element.isChecked(cbxSoundDef);
		if (isSoundDef) {
			aaoh.kaze.Element.setEnabled(txtSound, false);
			aaoh.kaze.Element.setEnabled(btnSound, false);

			var soundFile = aaoh.sora.App.control.DEFAULT_SOUND_FILE;
			aaoh.kaze.Element.setValue(txtSound, soundFile);

		} else {
			aaoh.kaze.Element.setEnabled(txtSound, true);
			aaoh.kaze.Element.setEnabled(btnSound, true);
		} // if (isSoundDef)
	}

	/**
	 * 音源ファイルの選択。
	 */
	aclock.Option.prototype.
	browseSoundFile = function() {
		aaoh.kaze.Gadget.browseForFile(
			this.filter,
			this.filterName1, this.filterExt1, this.filterName2, this.filterExt2,
			function(selectFile) {
			var txtSound  = aaoh.kaze.Gadget.$('txtSound');
			aaoh.kaze.Element.setValue(txtSound, selectFile);
		}, this);
	}

	/**
	 * 音源ファイルの再生。
	 */
	aclock.Option.prototype.
	soundPlay = function() {
		var cbxSoundDef = aaoh.kaze.Gadget.$('cbxSoundDef');
		var isSoundDef  = aaoh.kaze.Element.isChecked(cbxSoundDef);

		var soundFile = null;
		if (isSoundDef) {
			soundFile = aaoh.sora.App.control.DEFAULT_SOUND_FILE;

		} else {
			var txtSound  = aaoh.kaze.Gadget.$('txtSound');
			soundFile = aaoh.kaze.Element.getValue(txtSound);
		} // if (isSoundDef)

		if (soundFile != null && soundFile != '') {
			var isSoundVol = aaoh.sora.App.control.sound.isVolume();
			if (isSoundVol) {
				var selSoundVol = aaoh.kaze.Gadget.$('selSoundVol');
				var numSoundVol = parseInt(
					aaoh.kaze.Element.getSelected(selSoundVol), 10
				);

				aaoh.sora.App.control.sound.setVolume(numSoundVol);
			}

			aaoh.sora.App.control.sound.play(soundFile);
		} // if (soundFile != null && soundFile != '')
	}

	/**
	 * 音源ファイルの停止。
	 */
	aclock.Option.prototype.
	soundStop = function() {
		aaoh.sora.App.control.sound.stop();
	}

	/**
	 * 設定データの設定。
	 */
	aclock.Option.prototype.
	doOption = function() {
		// type
		for (var cnt = 1; cnt <= 3; cnt++) {
			var rdoType = aaoh.kaze.Gadget.$('rdoType' + cnt);
			var flgType = aaoh.kaze.Element.isChecked(rdoType);

			if (flgType) {
				aaoh.sora.App.model.data.type = String(cnt);
				break;
			}
		}

		// isDispSec
		var cbxDispSec = aaoh.kaze.Gadget.$('cbxDispSec');
		var isDispSec  = aaoh.kaze.Element.isChecked(cbxDispSec);
		aaoh.sora.App.model.data.isDispSec = isDispSec;

		// isSnooze
		var cbxSnooze = aaoh.kaze.Gadget.$('cbxSnooze');
		var isSnooze  = aaoh.kaze.Element.isChecked(cbxSnooze);
		aaoh.sora.App.model.data.isSnooze = isSnooze;

		// isAlert
		var cbxAlert = aaoh.kaze.Gadget.$('cbxAlert');
		var isAlert  = aaoh.kaze.Element.isChecked(cbxAlert);
		aaoh.sora.App.model.data.isAlert = isAlert;

		if (isAlert) {
			// isAlertDef
			var cbxAlertDef = aaoh.kaze.Gadget.$('cbxAlertDef');
			var isAlertDef  = aaoh.kaze.Element.isChecked(cbxAlertDef);
			aaoh.sora.App.model.data.isAlertDef = isAlertDef;

			// alertMsg
			if (!isAlertDef) {
				var txtAlert = aaoh.kaze.Gadget.$('txtAlert');
				var alertMsg = aaoh.kaze.Element.getValue(txtAlert);
				aaoh.sora.App.model.data.alertMsg = alertMsg;
			}
		} // if (isAlert)

		// isSound
		var cbxSound = aaoh.kaze.Gadget.$('cbxSound');
		var isSound  = aaoh.kaze.Element.isChecked(cbxSound);
		aaoh.sora.App.model.data.isSound = isSound;

		if (isSound) {
			// isSoundDef
			var cbxSoundDef = aaoh.kaze.Gadget.$('cbxSoundDef');
			var isSoundDef  = aaoh.kaze.Element.isChecked(cbxSoundDef);
			aaoh.sora.App.model.data.isSoundDef = isSoundDef;

			// soundFile
			if (!isSoundDef) {
				var txtSound  = aaoh.kaze.Gadget.$('txtSound');
				var soundFile = aaoh.kaze.Element.getValue(txtSound);
				aaoh.sora.App.model.data.soundFile = soundFile;
			}

			// numSoundVol
			var selSoundVol = aaoh.kaze.Gadget.$('selSoundVol');
			var numSoundVol = parseInt(
				aaoh.kaze.Element.getSelected(selSoundVol), 10
			);
			aaoh.sora.App.model.data.numSoundVol = numSoundVol;
		} // if (isSound)
	}

	/**
	 * 表示データの初期化。
	 */
	aclock.Option.prototype.
	initData = function() {
		// デフォルト値の更新
		aaoh.sora.App.control.DEFAULT_ALERT_MSG
			= aaoh.sora.App.control.locale.getString('ALERT_MSG');

		this.initTitleData();
		this.initDefaultData();
	}

	/**
	 * 表示データの初期化(タイトル)。
	 */
	aclock.Option.prototype.
	initTitleData = function() {
		var lblType       = aaoh.kaze.Gadget.$('lblType');
		var lblType1      = aaoh.kaze.Gadget.$('lblType1');
		var lblType2      = aaoh.kaze.Gadget.$('lblType2');
		var lblType3      = aaoh.kaze.Gadget.$('lblType3');
		var lblDispSec    = aaoh.kaze.Gadget.$('lblDispSec');
		var lblSnooze     = aaoh.kaze.Gadget.$('lblSnooze');
		var lblAlert      = aaoh.kaze.Gadget.$('lblAlert');
		var lblAlertDef   = aaoh.kaze.Gadget.$('lblAlertDef');
		var lblSound      = aaoh.kaze.Gadget.$('lblSound');
		var lblSoundDef   = aaoh.kaze.Gadget.$('lblSoundDef');
		var lblSoundVol   = aaoh.kaze.Gadget.$('lblSoundVol');
		var btnSoundStart = aaoh.kaze.Gadget.$('btnSoundStart');
		var btnSoundStop  = aaoh.kaze.Gadget.$('btnSoundStop');

		var ttlType       = aaoh.sora.App.control.locale.getString('TTL_TYPE');
		var ttlType1      = aaoh.sora.App.control.locale.getString('TTL_TYPE1');
		var ttlType2      = aaoh.sora.App.control.locale.getString('TTL_TYPE2');
		var ttlType3      = aaoh.sora.App.control.locale.getString('TTL_TYPE3');
		var ttlDispSec    = aaoh.sora.App.control.locale.getString('TTL_DISP_SEC');
		var ttlSnooze     = aaoh.sora.App.control.locale.getString('TTL_SNOOZE');
		var ttlAlert      = aaoh.sora.App.control.locale.getString('TTL_ALERT');
		var ttlAlertDef   = aaoh.sora.App.control.locale.getString('TTL_ALERT_DEF');
		//var ttlAlertMsg   = aaoh.sora.App.control.locale.getString('TTL_ALERT_MSG');
		var ttlSound      = aaoh.sora.App.control.locale.getString('TTL_SOUND');
		var ttlSoundDef   = aaoh.sora.App.control.locale.getString('TTL_ALERT_DEF');
		//var ttlSoundFile  = aaoh.sora.App.control.locale.getString('TTL_SOUND_FILE');
		var ttlSoundVol   = aaoh.sora.App.control.locale.getString('TTL_SOUND_VOL');
		var ttlSoundStart = aaoh.sora.App.control.locale.getString('TTL_SOUND_START');
		var ttlSoundStop  = aaoh.sora.App.control.locale.getString('TTL_SOUND_STOP');

		aaoh.kaze.Element.setValue(lblType,       ttlType);
		aaoh.kaze.Element.setValue(lblType1,      ttlType1);
		aaoh.kaze.Element.setValue(lblType2,      ttlType2);
		aaoh.kaze.Element.setValue(lblType3,      ttlType3);
		aaoh.kaze.Element.setValue(lblDispSec,    ttlDispSec);
		aaoh.kaze.Element.setValue(lblSnooze,     ttlSnooze);
		aaoh.kaze.Element.setValue(lblAlert,      ttlAlert);
		aaoh.kaze.Element.setValue(lblAlertDef,   ttlAlertDef);
		aaoh.kaze.Element.setValue(lblSound,      ttlSound);
		aaoh.kaze.Element.setValue(lblSoundDef,   ttlSoundDef);
		aaoh.kaze.Element.setValue(lblSoundVol,   ttlSoundVol);
		aaoh.kaze.Element.setValue(btnSoundStart, ttlSoundStart);
		aaoh.kaze.Element.setValue(btnSoundStop,  ttlSoundStop);

		this.filter      = aaoh.sora.App.control.locale.getString('SOUND_FILTER');
		this.filterName1 = aaoh.sora.App.control.locale.getString('SOUND_FILTER_NAME1');
		this.filterExt1  = aaoh.sora.App.control.locale.getString('SOUND_FILTER_EXT1');
		this.filterName2 = aaoh.sora.App.control.locale.getString('SOUND_FILTER_NAME2');
		this.filterExt2  = aaoh.sora.App.control.locale.getString('SOUND_FILTER_EXT2');
	}

	/**
	 * 表示データの初期化(デフォルト)。
	 */
	aclock.Option.prototype.
	initDefaultData = function() {
		// type
		var rdoType = aaoh.kaze.Gadget.$(
			'rdoType' + aaoh.sora.App.model.data.type
		);
		aaoh.kaze.Element.setChecked(rdoType, true);

		// isDispSec
		var cbxDispSec = aaoh.kaze.Gadget.$('cbxDispSec');
		aaoh.kaze.Element.setChecked(
			cbxDispSec, aaoh.sora.App.model.data.isDispSec
		);

		// isSnooze
		var cbxSnooze = aaoh.kaze.Gadget.$('cbxSnooze');
		aaoh.kaze.Element.setChecked(
			cbxSnooze, aaoh.sora.App.model.data.isSnooze
		);

		// isAlert
		var cbxAlert = aaoh.kaze.Gadget.$('cbxAlert');
		aaoh.kaze.Element.setChecked(
			cbxAlert, aaoh.sora.App.model.data.isAlert
		);

		// isAlertDef
		var cbxAlertDef = aaoh.kaze.Gadget.$('cbxAlertDef');
		aaoh.kaze.Element.setChecked(
			cbxAlertDef, aaoh.sora.App.model.data.isAlertDef
		);

		// alertMsg
		var txtAlert = aaoh.kaze.Gadget.$('txtAlert');
		if (aaoh.sora.App.model.data.isAlertDef) {
			aaoh.kaze.Element.setValue(
				txtAlert, aaoh.sora.App.control.DEFAULT_ALERT_MSG
			);

		} else {
			aaoh.kaze.Element.setValue(
				txtAlert, aaoh.sora.App.model.data.alertMsg
			);
		}

		// isSound
		var cbxSound = aaoh.kaze.Gadget.$('cbxSound');
		aaoh.kaze.Element.setChecked(
			cbxSound, aaoh.sora.App.model.data.isSound
		);

		// isSoundDef
		var cbxSoundDef = aaoh.kaze.Gadget.$('cbxSoundDef');
		aaoh.kaze.Element.setChecked(
			cbxSoundDef, aaoh.sora.App.model.data.isSoundDef
		);

		// soundFile
		var txtSound = aaoh.kaze.Gadget.$('txtSound');
		if (aaoh.sora.App.model.data.isSoundDef) {
			var soundFile = aaoh.sora.App.control.DEFAULT_SOUND_FILE;
			aaoh.kaze.Element.setValue(txtSound, soundFile);

		} else {
			aaoh.kaze.Element.setValue(
				txtSound, aaoh.sora.App.model.data.soundFile
			);
		}

		// numSoundVol
		var selSoundVolItem = aaoh.kaze.Gadget.$(
			'selSoundVol_' + aaoh.sora.App.model.data.numSoundVol
		)
		aaoh.kaze.Element.setSelected(selSoundVolItem, true);

		// isAlert
		this.setAlert();

		// isSound
		this.setSound();
	}

	/**
	 * 表示データの初期化(Yahoo)。
	 */
	aclock.Option.prototype.
	initDataForYahoo = function() {
		var ttlType      = aaoh.sora.App.control.locale.getString('TTL_TYPE');
		var ttlType1     = aaoh.sora.App.control.locale.getString('TTL_TYPE1');
		var ttlType2     = aaoh.sora.App.control.locale.getString('TTL_TYPE2');
		var ttlType3     = aaoh.sora.App.control.locale.getString('TTL_TYPE3');
		var ttlDispSec   = aaoh.sora.App.control.locale.getString('TTL_DISP_SEC');
		var ttlSnooze    = aaoh.sora.App.control.locale.getString('TTL_SNOOZE');
		var ttlAlert     = aaoh.sora.App.control.locale.getString('TTL_ALERT');
		var ttlAlertDef  = aaoh.sora.App.control.locale.getString('TTL_ALERT_DEF');
		var ttlAlertMsg  = aaoh.sora.App.control.locale.getString('TTL_ALERT_MSG');
		var ttlSound     = aaoh.sora.App.control.locale.getString('TTL_SOUND');
		var ttlSoundDef  = aaoh.sora.App.control.locale.getString('TTL_SOUND_DEF');
		var ttlSoundVol  = aaoh.sora.App.control.locale.getString('TTL_SOUND_VOL');
		var ttlSoundFile = aaoh.sora.App.control.locale.getString('TTL_SOUND_FILE');

		// alertMsg
		var alertMsg = null;
		if (aaoh.sora.App.model.data.isAlertDef) {
			alertMsg = aaoh.sora.App.control.DEFAULT_ALERT_MSG;

		} else {
			alertMsg = aaoh.sora.App.model.data.alertMsg;
		}

		var soundFile = null;
		if (aaoh.sora.App.model.data.isSoundDef) {
			soundFile = aaoh.sora.App.control.DEFAULT_SOUND_FILE;

		} else {
			soundFile = aaoh.sora.App.model.data.soundFile;
		}

		preferences.type.title        = ttlType;
		preferences.type.option[0]    = ttlType1;
		preferences.type.option[1]    = ttlType2;
		preferences.type.option[2]    = ttlType3;
		preferences.isDispSec.title   = ttlDispSec;
		preferences.isSnooze.title    = ttlSnooze;
		preferences.isAlert.title     = ttlAlert;
		preferences.isAlertDef.title  = ttlAlertDef;
		preferences.alertMsg.title    = ttlAlertMsg;
		preferences.alertMsg.value    = alertMsg;
		preferences.isSound.title     = ttlSound;
		preferences.isSoundDef.title  = ttlSoundDef;
		preferences.numSoundVol.title = ttlSoundVol;
		preferences.soundFile.title   = ttlSoundFile;
		preferences.soundFile.value   = soundFile;
	}

	/**
	 * イベントの設定。
	 */
	aclock.Option.prototype.
	setEventListener = function() {
		var cbxAlert = aaoh.kaze.Gadget.$('cbxAlert');
		if (cbxAlert != null) {
			aaoh.kaze.Element.setOnChange(cbxAlert, function() {
				aaoh.sora.App.option.setAlert();
			});
		}

		var cbxAlertDef = aaoh.kaze.Gadget.$('cbxAlertDef');
		if (cbxAlertDef != null) {
			aaoh.kaze.Element.setOnChange(cbxAlertDef, function() {
				aaoh.sora.App.option.setAlertMsg();
			});
		}

		var cbxSound = aaoh.kaze.Gadget.$('cbxSound');
		if (cbxSound != null) {
			aaoh.kaze.Element.setOnChange(cbxSound, function() {
				aaoh.sora.App.option.setSound();
			});
		}

		var cbxSoundDef = aaoh.kaze.Gadget.$('cbxSoundDef');
		if (cbxSoundDef != null) {
			aaoh.kaze.Element.setOnChange(cbxSoundDef, function() {
				aaoh.sora.App.option.setSoundFile();
			});
		}

		var btnSound = aaoh.kaze.Gadget.$('btnSound');
		if (btnSound != null) {
			aaoh.kaze.Element.setOnClick(btnSound, function() {
				aaoh.sora.App.option.browseSoundFile();
			});
		}

		var btnSoundStart = aaoh.kaze.Gadget.$('btnSoundStart');
		if (btnSoundStart != null) {
			aaoh.kaze.Element.setOnClick(btnSoundStart, function() {
				aaoh.sora.App.option.soundPlay();
			});
		}

		var btnSoundStop = aaoh.kaze.Gadget.$('btnSoundStop');
		if (btnSoundStop != null) {
			aaoh.kaze.Element.setOnClick(btnSoundStop, function() {
				aaoh.sora.App.option.soundStop();
			});
		}
	}

	/**
	 * 初期化処理(画面表示)。
	 */
	aclock.Option.prototype.
	initDisplay = function() {
		// アラート表示できないときには非表示
		if (!aaoh.kaze.Gadget.isConfirm()) {
			var alertObj = aaoh.kaze.Gadget.$('alert');
			if (alertObj != null) {
				aaoh.kaze.Element.setDisplay(alertObj, false);
			}
		}

		// 音の再生できないときには非表示
		var isSound = aaoh.sora.App.control.sound.isSound();
		if (!isSound) {
			var sound = aaoh.kaze.Gadget.$('sound');
			if (sound != null) {
				aaoh.kaze.Element.setDisplay(sound, false);
			}
		}

		// 音量の設定できないときには非表示
		var isSoundVol = aaoh.sora.App.control.sound.isVolume();
		if (!isSoundVol) {
			var soundVol = aaoh.kaze.Gadget.$('soundVol');
			if (soundVol != null) {
				aaoh.kaze.Element.setDisplay(soundVol, false);
			}
		}
	}

	/**
	 * 初期化処理。
	 */
	aclock.Option.prototype.
	init = function() {
		this.setEventListener();
		this.initDisplay();
	}
})();
